#include "myWin.h"
//ȉRs͍Đp
#include "windows.h"            //Đp錾
#include "MMSystem.h"           //Đp錾
#pragma comment(lib,"winmm.lib")//Đp錾
#include "stdio.h"
#include "stdlib.h"
#include "math.h"
#include "string.h"
#define swap(type, X,Y) do{type T; T=X; X=Y; Y=T;}while(0)
#define LB_1    1001
#define LB_2    1002
#define LB_3    1003
#define ED_FRQ  2000
#define ED_COF1 2100
#define ED_COF2 2150
#define ED_DLY  2201
#define ED_POW  2202
#define ED_FR1  2203
#define ED_FR2  2204
#define BT_GEN  3001
#define BT_PLY  3002
#define PI      3.14159265358979
#define LS_1   4001
#define NUMFRQ  8
int size;
char *buf;
static HWND edFrq[NUMFRQ], edCof1[NUMFRQ], edCof2[NUMFRQ], edDelay, edPow;
static HWND btGen, btPlay,btReset, label,list;
static double freq[NUMFRQ], coff1[NUMFRQ],coff2[NUMFRQ],sumCoff;
// 44100Hz, 8bit, 1ch WAVf[^
#define SAMPLFRQ 44100
#define BIT  8
void intToByte(char BT[], int DT){//32rbgi[
	BT[0] =  DT       & 0xff; BT[1] =  DT >> 8  & 0xff;
	BT[2] =  DT >> 16 & 0xff; BT[3] =  DT >> 24 & 0xff;
}
void shortToByte(char BT[], int DT){//16rbgi[
	BT[0] =  DT       & 0xff; BT[1] =  DT >> 8  & 0xff;
}
int wav_write(const char *filename, char *buf, int size){
	int filesize = 44 + size; char *tmp; tmp = (char *) malloc(filesize);//̈m
	if(tmp==NULL) return 1;
	//o̓f[^ݒ-------------------------------------------------------------------------
	memcpy(tmp, "RIFF", 4);			      // RIFFwb_
	intToByte(tmp+4,filesize - 8);        // ȍ~̃t@CTCY (t@CTCY - 8)
	memcpy(tmp+8, "WAVE", 4);             // WAVEwb_ 
	memcpy(tmp+12, "fmt ", 4);            // fmt`N
	intToByte(tmp+16,16 );                // oCg fmt `ÑoCg(jAPCM ̂Ƃ 16(10 00 00 00))
	shortToByte(tmp+20, 1); 	          // tH[}bgID (jAPCM ̂Ƃ 1(01 00)) 
	shortToByte(tmp+22, 1);               // `l m ̂Ƃ 1(01 00)
	intToByte(tmp+24,SAMPLFRQ );          // TvO[g
	intToByte(tmp+28,SAMPLFRQ * (BIT/8)); // f[^x (Byte/sec) 
	shortToByte(tmp+32, BIT / 8);         // ubNTCY 
	shortToByte(tmp+34, BIT);             // Tṽrbg 
	memcpy(tmp+36, "data", 4);            // data `N
	intToByte(tmp+40,size);               // oCg
	memcpy(tmp + 44, buf, size);          // 
	//t@Co----------------------------------------------------------------------------
	FILE *fp = fopen(filename, "wb"); if (fp == NULL) return 2;
	fwrite(tmp, filesize, 1, fp);         // t@Cւ̏o
	fclose(fp);                           // t@CN[Y
	free(tmp);                            // ̈ԋp
	return 0;
}
void createLabel(HWND *label,HWND hw, TCHAR name[],int X, int Y, int W,int H, int No){
	*label=CreateWindow(TEXT("STATIC"),name,
		WS_CHILD|WS_VISIBLE|SS_LEFT,
		X,Y, W, H,hw,(HMENU)No,hInstance,NULL);
}
void createEdit(HWND *edit,HWND hw, TCHAR name[],int X, int Y, int W,int H, int No){
	*edit=CreateWindow(TEXT("EDIT"),name,
		WS_CHILD|WS_VISIBLE|WS_BORDER|ES_RIGHT, 
		X,Y, W, H,hw,(HMENU)No,hInstance,NULL);
}
void createList(HWND *list,HWND hw, int X, int Y, int W,int H, int No){
	*list=CreateWindow(TEXT("LISTBOX"),NULL,
		WS_CHILD|WS_VISIBLE|WS_BORDER, 
		X,Y, W, H,hw,(HMENU)No,hInstance,NULL);
}
void createButton(HWND *edit,HWND hw, TCHAR name[],int X, int Y, int W,int H, int No){
	*edit=CreateWindow(TEXT("BUTTON"),name,
		WS_CHILD|WS_VISIBLE|WS_BORDER|BS_PUSHBUTTON, 
		X,Y, W, H,hw,(HMENU)No,hInstance,NULL);
}
int bufSize(int sec){return (SAMPLFRQ*(BIT/8)) * sec;}
void procCreate(HWND hw, WPARAM wp,LPARAM lp){ 
	int X0=20;
	TCHAR *frStr[]={
		TEXT("500" ),TEXT("1000"),TEXT("1500"),TEXT("2000"),
		TEXT("2500"),TEXT("3000"),TEXT("3500"),TEXT("4000")
	};
	TCHAR *frCof1[]={
		TEXT("16" ),TEXT("10"),TEXT("8"),TEXT("6"),
		TEXT("4"),TEXT("3"),TEXT("2"),TEXT("1")
	};
	
	TCHAR *frCof2[]={
		TEXT("16" ),TEXT("10"),TEXT("8"),TEXT("6"),
		TEXT("4"),TEXT("3"),TEXT("2"),TEXT("1")
	};
	TCHAR *lstStr[]={TEXT("Linear"), TEXT("Exp(X)"), TEXT("Exp(-X)*X^S")}; 
	createLabel(&label,hw,TEXT("g")              , X0, 5, 80,30, LB_1);
	createLabel(&label,hw,TEXT("sinU")           , X0, 35,80,30, LB_2);
	createLabel(&label,hw,TEXT("cosU")           , X0, 65,80,30, LB_2);
	createLabel(&label,hw,TEXT("")              , X0, 95,80,30, LB_2);
	createLabel(&label,hw,TEXT("ׂ")              , X0, 125,80,30, LB_2);
	createLabel(&label,hw,TEXT("Gx[up^["), X0, 155,200,30, LB_2);
	int X=X0+75;
	for(int i=0;i<NUMFRQ;i++, X+=55){
		createEdit(&(edFrq[i]),hw,frStr[i] , X,  5, 50,22, ED_FRQ+i);
		createEdit(&(edCof1[i]),hw,frCof1[i], X, 35, 50,22, ED_COF1+i);
		createEdit(&(edCof2[i]),hw,frCof2[i], X, 65, 50,22, ED_COF2+i);
	}
	createEdit(&edDelay,hw,TEXT("5"), X0+75, 95, 50,22, ED_DLY);
	createEdit(&edPow,hw,TEXT("1"), X0+75, 125, 50,22, ED_POW);
	createList(&list,hw,X0, 175, 190,60, LS_1);
	for(int i=0;i<3;i++, X+=45){
		SendMessage(list, LB_INSERTSTRING, i, (LPARAM)lstStr[i]);
	}
	SendMessage(list, LB_SETCURSEL, 1,0);
	createButton(&btGen   ,hw,TEXT("ƍĐ"    ), X0+130,  95,105,25, BT_GEN);
	createButton(&btPlay  ,hw,TEXT("Đ̂"      ), X0+130, 125,105,25, BT_PLY);
	SetWindowText(hw,TEXT("F̍"));
    MoveWindow(hw, 0,0,600,300,TRUE);
	size = bufSize(1);     //1b
	buf=(char *) malloc(size);
}
double getEdit(HWND edit){
	TCHAR tstr[128];char str[128];double r;int i;
	GetWindowText(edit,tstr,127);
	for(i=0;i<127 &&  tstr[i]!=0;i++) str[i]=(char)tstr[i];
	str[i]=0;
	sscanf(str,"%lf", &r);return r;
}
double getFreqCof(double freq[], double coff1[], double coff2[]){
	double PI2D=2.0*PI/SAMPLFRQ;double sumCoff=0;
	for(int i=0;i<NUMFRQ;i++){
		freq[i]=getEdit(edFrq[i])*PI2D;
		coff1[i]=getEdit(edCof1[i]);coff2[i]=getEdit(edCof2[i]);
		sumCoff+=(coff1[i]+coff1[i]);
	}
	return sumCoff;
}
void genLinear(){
	double w, X=(double)1/SAMPLFRQ; sumCoff=getFreqCof(freq, coff1,coff2);
	for(int i=0; i<size;i++){
		w=0; double XI=(1-i*X);
		for(int j=0;j<NUMFRQ;j++) 
			w+= XI*(sin((double)i*freq[j])*coff1[j]+cos((double)i*freq[j])*coff2[j]); 
		buf[i]=(char)(127.0*w/sumCoff)+128;
	}
}
void genExp(double E){
	double w, X=(double)E/SAMPLFRQ;	sumCoff=getFreqCof(freq, coff1,coff2);
	for(int i=0; i<size;i++){
		w=0;double XI=exp(-X*i);
		for(int j=0;j<NUMFRQ;j++) w+= XI*(sin((double)i*freq[j])*coff1[j]+cos((double)i*freq[j])*coff2[j]); ;
		buf[i]=(char)(127.0*w/sumCoff)+128;
	}
}
void genExp(){ double D=getEdit(edDelay); genExp(D);}
void genExpPow(){
	double w, X,E, B=1, S=getEdit(edPow); if(S>0) B =exp(1.0)-0.5;
	E=getEdit(edDelay); X=(double)E/SAMPLFRQ; 
	sumCoff=getFreqCof(freq, coff1,coff2);
	for(int i=0; i<size;i++){
		w=0;double XI=X*i, XIJ=exp(-XI)*pow(XI,S);
		for(int j=0;j<NUMFRQ;j++) 
			w+= B*XIJ*(sin((double)i*freq[j])*coff1[j]+cos((double)i*freq[j])*coff2[j]);
		buf[i]=(char)(127.0*w/sumCoff)+128;
	}
}

void procPlayCheck(HWND hw){
	int r=wav_write("test.wav", buf, size);
	if     (r==0) {
		PlaySound(TEXT("test.wav"),NULL,SND_FILENAME|SND_ASYNC);//Đ
	}
	else if(r==1) {
		MessageBox(hw, TEXT("̈mێs.I܂."),TEXT("G["),MB_OK);
		PostQuitMessage(0);
	}
	else if(r==2) {
		MessageBox(hw, TEXT("t@CI[vG["),TEXT("G["),MB_OK);
		free(buf); PostQuitMessage(0);
	}
}
void procReset(HWND hw){
	int FST=(int)getEdit(edFrq[0]);
	TCHAR str[256];
    for(int i=1;i<NUMFRQ;i++){
		wsprintf(str,TEXT("%d"), FST*(i+1));
		SetWindowText(edFrq[i],str);
	}
}
void procGeneration(HWND hw){
	int r=SendMessage(list, LB_GETCURSEL,0,0L);
	switch(r){
	case   0   : genLinear()  ;break;
	case   1   : genExp()     ;break;
	case   2   : genExpPow()  ;break;
	case LB_ERR: genExp();break;
	default : return ;
	}
	procPlayCheck(hw);return;
}
void procPlay(HWND hw){
	PlaySound(TEXT("test.wav"),NULL,SND_FILENAME|SND_ASYNC);//Đ
	Sleep(1000);
}
void procEditFrq(HWND hw, WPARAM wp,LPARAM lp){
	switch(HIWORD(wp)){
	case EN_UPDATE:  procReset(hw);return;
	}
}
void procCommand(HWND hw, WPARAM wp,LPARAM lp){
	switch(LOWORD(wp)){
	case BT_GEN: procGeneration(hw);return;
	case BT_PLY: procPlay(hw)      ;return;
	case ED_FRQ: procEditFrq(hw,wp,lp);
	}
}
LRESULT CALLBACK WndProc(HWND hw, UINT msg, WPARAM wp,LPARAM lp){
	switch(msg){
 	case WM_DESTROY  : free(buf); PostQuitMessage(0)   ;return 0;
	case WM_CREATE   : procCreate (hw,wp,lp);return 0;
	case WM_COMMAND  : procCommand(hw,wp,lp);return 0;
	}
	return DefWindowProc(hw,msg,wp,lp);
} 
